version: "3.4"
services:
  zookeeper:
    image: debezium/zookeeper:1.1
    ports:
      - "2181:2181"
      - "2888:2888"
      - "3888:3888"

  kafka:
    image: debezium/kafka:1.1
    ports:
      - "9092:9092"
    links:
      - zookeeper
    environment:
      - ZOOKEEPER_CONNECT=zookeeper:2181
      - ADVERTISED_HOST_NAME=kafka

  connect:
    build: ./debezium-jdbc-es
    ports:
      - "8083:8083"
      - "5005:5005"
    links:
      - kafka
      - elasticsearch
    environment:
     - BOOTSTRAP_SERVERS=kafka:9092
     - GROUP_ID=1
     - CONFIG_STORAGE_TOPIC=my_connect_configs
     - OFFSET_STORAGE_TOPIC=my_connect_offsets
     - STATUS_STORAGE_TOPIC=my_source_connect_statuses

  postgres:
    image: postgis/postgis:13-master    # image: postgres:12
    ports:
      - "5432:5432"
    volumes:
      - ./postgres/docker-entrypoint-initdb.d:/docker-entrypoint-initdb.d
      - ./postgres/conf.d:/conf.d
      - ${SHARED_VOLUME}:/shared-volume
    environment:
      - POSTGRES_DB=${POSTGRES_DB}
      - POSTGRES_USER=${POSTGRES_USER}
      - POSTGRES_PASSWORD=${POSTGRES_PASSWORD}

  elasticsearch:
    image: docker.elastic.co/elasticsearch/elasticsearch-oss:7.6.1
    ports:
      - "9200:9200"
    expose: 
      - "9200"  
    environment:
      http.host: 0.0.0.0
      transport.host: 127.0.0.1
      discovery.type: "single-node"
      cluster.routing.allocation.disk.threshold_enabled: "false"
      ES_JAVA_OPTS: "-Xms512m -Xmx512m"

  kibana:
    image: docker.elastic.co/kibana/kibana-oss:7.6.1
    links:
      - elasticsearch
    ports:
      - "5601:5601"

  grafana:
    image: grafana/grafana:7.3.2
    ports:
      - "3000:3000"
    environment:
      - GF_INSTALL_PLUGINS=${GRAFANA_INSTALL_PLUGINS}
      - GF_AUTH_DISABLE_LOGIN_FORM=true
      - GF_AUTH_ANONYMOUS_ENABLED=true
      - GF_AUTH_ANONYMOUS_ORG_NAME=Main Org.
      - GF_AUTH_ANONYMOUS_ORG_ROLE=Admin
      - GF_USERS_ALLOW_SIGN_UP=false
